proc NASTRANWindonsMat { } {
    
    GiD_DataBehaviour materials Isotropic hide {delete}
    GiD_DataBehaviour materials Material hide {assign draw unassign}
    GiD_DataBehaviour materials Tables hide {assign draw unassign}
   
   
 }
 proc NastranBase2PostCmdAssignMat { GDN w Menu geomlist } {
     $Menu del 0 end
     if { [catch { set whatuse [lindex [.gid.central.s info Project] 4] }] } {
	 set whatuse GEOMETRYUSE
     }
     switch $whatuse {
	 GEOMETRYUSE {
	     foreach i $geomlist {
		 $Menu add command -label $i -command "DWAssignMaterials $GDN $w $i"
	     }
	 }
	 MESHUSE {
	     $Menu add command -label Elements -command "DWAssignMaterials $GDN $w Elements"
	 }
     }
 }
 proc NastranBasePostCmdAssignMat { GDN w Menu } {
	
     if { [::GidUtils::VersionCmp 7.4.1b] >= 0 } { 
	 set _MatName [DWGetCurrentMaterial $GDN] 
     } else {
	 upvar \#0 $GDN GidData
	 set _MatName [DWSpace2Under $GidData(MAT,matname)] ;#deprecated
     }
 
     set property [lindex [.central.s info Materials $_MatName] 4]
     set book [.central.s info Materials $_MatName BOOK]
 
     set LinesMats [list BAR BEAM TUBE VISCOUS_DAMPER SPRING DOF_SPRING ROD]
     set SurfacesMats [list PLATE SHEAR_PANEL LAMINATE ]
     set VolumesMats [list TETRAHEDRON HEXAHEDRON] 
     if { [lsearch $LinesMats $property] != -1 } {
	 NastranBase2PostCmdAssignMat $GDN $w $Menu Lines
     } elseif { [lsearch $SurfacesMats $property] != -1 } {
	 NastranBase2PostCmdAssignMat $GDN $w $Menu Surfaces
     } elseif { [lsearch $VolumesMats $property] != -1 } {
	 NastranBase2PostCmdAssignMat $GDN $w $Menu Volumes
     } elseif { $book != "Material" && $book != "Tables"} {
	 NastranPostCmdAssignMat $GDN $w $Menu
     }
#    else {
#         $Menu del 0 end
#        $Menu add command -label "This material or table cannot be assigned"
#     }
 }
 
proc InitGIDProject { dir } {
    global MenuNames MenuEntries MenuCommands MenuAcceler
    global MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP
    global ProgramName VersionNumber ProblemTypePriv NastranPriv
    global GidPriv
    
  
    
    set ProgramName [_ "GiD-NASTRAN Interface"] 
    set VersionNumber 2.4
    set VersionRequired "7.4.7b"
    set comp -1
    catch { 
     set comp [::GidUtils::VersionCmp $VersionRequired]
    }
    if { $comp < 0 } {
      WarnWin [_ "Error: GiD-NASTRAN Interface requires GiD $VersionRequired or later."]
    }
    catch { unset ProblemTypePriv }
    if { [info exists GidPriv(CalculationFileExtension)] } {
	set ProblemTypePriv(OldCalculationFileExtension) $GidPriv(CalculationFileExtension)
    }
    set GidPriv(CalculationFileExtension) ".nas"
    set ProblemTypePriv(problemtypedir) $dir
    
    catch {
		GidShowBook intvdata "" 0
    }
    NASTRANWindonsMat
    set ipos [lsearch $MenuNames [_ "Help"]]
    if { $ipos != -1 } {
	set MenuEntries($ipos) [linsert $MenuEntries($ipos) 0 [_ "GiD-NASTRAN Interface tutorials"] \
		"GiD-NASTRAN Interface help"]
	set MenuCommands($ipos) [linsert $MenuCommands($ipos) 0 \
		[list -np- HelpWindow [_ "CUSTOM_HELP_FILE"] \
		[file join $dir ../info nastran_tutorials.html]] \
		[list -np- HelpWindow [_ "CUSTOM_HELP_REFERENCE"] \
		[file join $dir ../info nastran_toc.html]]]
	set MenuAcceler($ipos) [linsert $MenuAcceler($ipos) 0 "" ""]

	lappend MenuEntries($ipos) [_ "About GiD-NASTRAN Interface"]
	lappend MenuCommands($ipos) [list -np- Splash $dir 0]
	lappend MenuAcceler($ipos) ""
    }
    set ipos [lsearch $MenuNamesP [_ "Help"]]
    if { $ipos != -1 } {
	set MenuEntriesP($ipos) [linsert $MenuEntriesP($ipos) 0 [_ "GiD-NASTRAN Interface tutorials"] \
		[_ "GiD-NASTRAN Interface help"] ]
	set MenuCommandsP($ipos) [linsert $MenuCommandsP($ipos) 0 \
		[list -np- HelpWindow [_ "CUSTOM_HELP_FILE"] \
		[file join $dir ../info nastran_tutorials.html]] \
		[list -np- HelpWindow [_ "CUSTOM_HELP_REFERENCE"] \
		[file join $dir ../info nastran_toc.html]]]
	set MenuAccelerP($ipos) [linsert $MenuAccelerP($ipos) 0 "" ""]

	lappend MenuEntriesP($ipos) [_ "About GiD-NASTRAN Interface"]
	lappend MenuCommandsP($ipos) [list -np- Splash $dir 0]
	lappend MenuAccelerP($ipos) ""
    }
	
    set ipos [lsearch $MenuNamesP [_ "Files"]]
    set iposin [lsearch $MenuEntriesP($ipos) [_ "Import"]]
    set MenuEntriesP($ipos,$iposin) [linsert $MenuEntriesP($ipos,$iposin) 2 [_ "FEMAP Info..."]]
    set MenuCommandsP($ipos,$iposin) [linsert $MenuCommandsP($ipos,$iposin) 2 [list -np- FemapInfo ]]
    set MenuEntriesP($ipos,$iposin) [linsert $MenuEntriesP($ipos,$iposin) 3 [_ "Import PUNCH"]]
    set MenuCommandsP($ipos,$iposin) [linsert $MenuCommandsP($ipos,$iposin) 3 [list -np- PCH2GiD $dir 1 0]]
    set MenuEntriesP($ipos,$iposin) [linsert $MenuEntriesP($ipos,$iposin) 4 [_ "Import PUNCH(Smooth)"]]
    set MenuCommandsP($ipos,$iposin) [linsert $MenuCommandsP($ipos,$iposin) 4 [list -np- PCH2GiD $dir 1 1]]
    #set MenuAccelerP($ipos,$iposin) [linsert $MenuAccelerP($ipos,$iposin) 2 ""]
    
    set GidVersion [.gid.central.s info GiDVersion]
    set GidVersion [string trim $GidVersion]
    set GidVersion [string index $GidVersion 0]
    
    if { $GidVersion <= 6 } {
	set iposin2 [lsearch $MenuEntriesP($ipos,$iposin) [_ "Image"]]
	set MenuEntriesP($ipos,$iposin,$iposin2) $MenuEntriesP($ipos,$iposin,[expr $iposin2-2])
	catch {unset MenuEntriesP($ipos,$iposin,[expr $iposin2-2])}
	set MenuCommandsP($ipos,$iposin,$iposin2) $MenuCommandsP($ipos,$iposin,[expr $iposin2-2])
	catch {unset MenuCommandsP($ipos,$iposin,[expr $iposin2-2])}
    }
    set ipos [lsearch $MenuNames [_ "Files"]]
    if { $ipos != -1 } {
	set ipos2 [lsearch $MenuEntries($ipos) [_ *Export*] ]
	if { $ipos2 != -1 } {
	    set ipos3 [lsearch $MenuEntries($ipos,$ipos2) [_ "*Calculation file*"] ]
	    if { $ipos3 != -1 } {
		set MenuCommands($ipos,$ipos2) [lreplace $MenuCommands($ipos,$ipos2) \
		        $ipos3 $ipos3 "-np- WriteCalcFileCheck"]
	    }
	}
    }
    
    set ipos [lsearch $MenuNames [_ "Calculate"] ]
    if { $ipos != -1 } {
	set ipos2 [lsearch $MenuEntries($ipos) Calculate]
	if { $ipos2 != -1 } {
	    set MenuCommands($ipos) [lreplace $MenuCommands($ipos) \
		        $ipos2 $ipos2 "-np- WriteCalcFileCheck"]
	}
    }
     foreach i [list helpviewer.tcl nastranpch2gid.tcl function.tcl supergrid.tcl \
	    tkcheckdata.tcl nassections.tcl composite.tcl verify_properties.tcl \
	    nasmat.tcl base64.tcl buttontable.tcl loadcases.tcl heatboundaries.tcl \
	    convection.tcl nastogid.tcl nasmat_anisotropicshell.tcl nasmat_orthotropicshell.tcl \
	    calcangle.tcl baswriter.tcl plate.tcl buttonmaterial.tcl materialsmatrixtemp.tcl] {
	source [file join $dir scripts $i]
    } 
#    source of encrypted file 
    loadtbefile [file join $dir scripts verifymodel.tbe]
    
    if { [catch {
	    LoadCasesInit $dir
	}] } {
	WarnWin [_ "$ProgramName is not compatible with this GiD version"]
	return
    }
  
      foreach i [list PostCmdAssignMat] {
	  if { [info command Nastran$i] == "" } {
	      rename $i Nastran$i
	     rename NastranBase$i $i
	  }
      }

    if { ![info exists  NastranPriv(infosplash)] } {
	catch { Splash $dir }
	set NastranPriv(infosplash) 1
    }

    
      
    MyBitmaps $dir

    GidChangeDataLabel [_ "Problem Data"] ""
    GidChangeDataLabel [_ "Conditions"] ""
    GidChangeDataLabel [_ "Materials"] ""
    GidChangeDataLabel [_ "Interval"] ""
    GidChangeDataLabel [_ "Interval Data"] ""
    
    GidAddUserDataOptions [_ "Load cases"] "LoadCaseWindow" 2
    GidAddUserDataOptionsMenu [_ "Boundary Conditions"] "NastranBoundaryconditionsSubmenu %W" 3
    GidAddUserDataOptionsMenu [_ "Loads"] "NastranLoadsSubmenu %W" 4
    GidAddUserDataOptions [_ "Advanced Conditions"] "GidOpenConditions Advanced_Conditions" 5
    GidAddUserDataOptions [_ "Materials"] "GidOpenMaterials Material" 6
    GidAddUserDataOptionsMenu [_ "Properties"] "NastranPropertiesSubmenu %W" 7
    GidAddUserDataOptionsMenu [_ "Analysis Design"] "NastranAnalysisSubmenu %W" 8
    GidAddUserDataOptionsMenu [_ "Problem data"] "NastranProblemdataSubmenu %W" 9
    GidAddUserDataOptions [_ "Verify Properties"] VerifyProperty 10
    GidAddUserDataOptions "---" "" 11  
	
    set GidPriv(ProgName) $ProgramName
    ChangeWindowTitle
    CreateTopMenus
}


proc NastranPropertiesSubmenu { w } {
    $w del 0 end
    $w add command -label [_ "Property"] -command [list GidOpenMaterials Property ]
    $w add command -label [_ "Local Axes"] -command [list GidOpenConditions Local_Axes ]
    $w configure -postcommand ""
}
proc NastranLoadsSubmenu { w } {
    $w del 0 end
    $w add command -label [_ "Static Loads"] -command [list GidOpenConditions Static_Loads ]
    $w add command -label [_ "Dynamics Loads"] -command [list GidOpenConditions Dynamics_Loads ]
    $w add command -label [_ "Thermal Loads"] -command [list GidOpenConditions Thermal_Loads ]
    $w add command -label [_ "Tables"] -command [list GidOpenMaterials Tables ]
    $w configure -postcommand ""
}
proc NastranBoundaryconditionsSubmenu { w } {
    $w del 0 end
    $w add command -label [_ "Constraints"] -command [list GidOpenConditions Constraints ]
    $w add command -label [_ "Connections"] -command [list GidOpenConditions Connections ]
     $w add command -label [_ "Heat Boundaries"] -command [list GidOpenConditions Heat_Boundaries ]
    $w configure -postcommand ""
}
proc NastranProblemdataSubmenu { w } {
    $w del 0 end
    $w add command -label [_ "Executive Control"] -command [list GidOpenProblemData Executive_Control]
    $w add command -label [_ "Case Control"] -command [list GidOpenProblemData Case_Control]
    $w add command -label [_ "Parameters"] -command [list GidOpenProblemData Parameters]
    $w configure -postcommand ""
}
proc NastranAnalysisSubmenu { w } {
    $w del 0 end
    $w add command -label [_ "Thermal"] -command [list GidOpenProblemData Thermal]
    $w add command -label [_ "Dynamics"] -command [list GidOpenProblemData Dynamics]
    $w add command -label [_ "Buckling"] -command [list GidOpenProblemData Buckling]
    $w add command -label [_ "NonLinear"] -command [list GidOpenProblemData NonLinear]
    $w configure -postcommand ""
}


proc EndGIDProject {} {
    global ProblemTypePriv
    
    if { [info exists ProblemTypePriv(condfuns)] } {
	foreach i $ProblemTypePriv(condfuns) {
	    rename $i {}
	    rename $i-base $i
	}
    }
    catch { destroy .gid.loadcases }
    foreach i [list PostCmdAssignMat DWDrawMaterials DWUnassignMat] {
	if { [info command Nastran$i] != "" } {
	    rename $i ""
	    rename Nastran$i $i
	}
    }
    global GidPriv
    set GidPriv(ProgName) GiD
    ChangeWindowTitle ""
    EndMyBitmaps
    if { [info exists ProblemTypePriv(OldCalculationFileExtension)] } {
	set GidPriv(CalculationFileExtension) $ProblemTypePriv(OldCalculationFileExtension)
    } else {
	unset GidPriv(CalculationFileExtension)
    }
}

proc Splash { dir { autodestroy 1 } } {
    global GIDDEFAULT VersionNumber ProgramName

    if { [.gid.central.s disable windows] } { return }

    if { [ winfo exist .splash]} {
	destroy .splash
	update
    }

    toplevel .splash
    wm withdraw .splash
	
    set im [image create photo -file [ file join $dir images \
	    [string tolower $ProgramName]-open.gif]]
    set x [expr [winfo screenwidth .splash]/2-[image width $im]/2]
    set y [expr [winfo screenheight .splash]/2-[image height $im]/2]

    wm geom .splash +$x+$y
    wm transient .splash .gid
    wm overrideredirect .splash 1
    pack [label .splash.l -image $im -relief ridge -bd 2]
    
    label .splash.lv -text $VersionNumber -foreground white -relief raised -bd 3 \
	    -background blue4 -font "verdana 8"
    place .splash.lv -x 62 -y 62
    bind .splash <1> "destroy .splash"
    bind .splash <KeyPress> "destroy .splash"
    grab .splash
    focus .splash
    update
    wm deiconify .splash
    raise .splash .gid
    update
    if { $autodestroy } {
	after 4000 "if { [ winfo exist .splash] } { 
	    destroy .splash
	}"
    }
    
}

proc PCH2GiD { dir reenterpost  smooth } {

    global DefaultSearchDirectory

    if { ![info exists DefaultSearchDirectory] || \
	     ![file isdirectory $DefaultSearchDirectory]} {
	set DefaultSearchDirectory [pwd]
    }
    set deft $DefaultSearchDirectory

    set filein [tk_getOpenFile -defaultextension ".pch"  -initialdir $deft \
		    -parent .gid -filetypes {{{PUNCH files} {.pch} } {{All files} {*} }}]
    if { $filein == "" } {
	return
    }
    set DefaultSearchDirectory [file dirname $filein]

    set aa [.central.s info Project]
    set ProjectName [lindex $aa 1]
    if { [file extension $ProjectName] == ".gid" } {
	set ProjectName [file root $ProjectName]
    }
    if { $ProjectName == "UNNAMED" } {
	tk_dialogRAM .gid.tmpwin error \
		  [_ "Before importing, a project title is needed. Save project to get it"] \
		  error 0 OK
	  return
    }

    set directory $ProjectName.gid
    if { [file pathtype $directory] == "relative" } {
	set directory [file join [pwd] $directory]
    }
    set fileout [file join $directory [file root [file tail $ProjectName]].flavia.res]
    
    PCH2GiD::TranslateW  $filein $fileout $smooth
    
    if { $reenterpost } {
	set DisableGraphics [.central.s disable graphics]
	set DisableWarnLine [.central.s disable warnline]
	.central.s disable graphics 1
	.central.s disable warnline 1
	.central.s process escape escape escape escape preprocess yes 
	.central.s process escape escape escape escape postprocess yes
	if { !$DisableGraphics } { .central.s disable graphics 0 }
	if { !$DisableWarnLine } { .central.s disable warnline 0 }
    }
}

proc FemapInfo { } {

    tk_dialogRAMFull .gid.alele {information window} \
	"It is only possible to import FEMAP\nneutral files in ASCII format.\nTo\
	obtain a FEMAP ASCII file in NE/NASTRAN go to NASTRAN Editor:\nMenu\
	Setup, Default Analysis Options.\nSelect RSLTFILETYPE,FEMAP ASCII\
	in Output Control Directives." \
	"" "" gidquestionhead 0 OK 
}

proc MyBitmaps { dir { type "DEFAULT INSIDELEFT"} } {
    global MyBitmapsNames MyBitmapsCommands MyBitmapsHelp ProblemTypePriv ProgramName

    set MyBitmapsNames(0) "images/l1.gif images/constraints.gif \
	images/heatboundaries.gif --- images/loads.gif images/dynamicloads.gif \
	images/thermalloads.gif --- \
	images/section.gif images/localaxes.gif --- \
	images/executivecontrol.gif images/casecontrol.gif --- images/dynamics.gif \
	images/buckling.gif images/nonlinear.gif --- images/mesh.gif images/calculate.gif"
    set MyBitmapsCommands(0) [list {} [list -np- GidOpenConditions Constraints] \
	     [list -np- GidOpenConditions Heat_Boundaries] \
	    "" \
	    [list -np- GidOpenConditions Static_Loads] \
	    [list -np- GidOpenConditions Dynamics_Loads] \
	    [list -np- GidOpenConditions Thermal_Loads] \
	    "" \
	     [list -np- GidOpenMaterials Property] \
	    [list -np- GidOpenConditions Local_Axes] \
	    "" \
	    [list -np- GidOpenProblemData Executive_Control] \
	    [list -np- GidOpenProblemData Case_Control] \
	    "" \
	    [list -np- GidOpenProblemData Dynamics] \
	    [list -np- GidOpenProblemData Buckling] \
	    [list -np- GidOpenProblemData  NonLinear] \
	    "" \
	    [_ "Meshing generate"] \
	    [list -np- WriteCalcFileCheck]]
    set MyBitmapsHelp(0) { {} "Assign Constraints" \
	    "Assign Heat Boundaries" \
	    "" \
	    "Assign Static Loads" \
	    "Assign Dynamic Loads" "Assign Thermal Loads" \
	    "" \
	    "Assign Properties" \
	    "Define Local Axes for 1-D elements\nDefine Material Orientation." \
	    "" \
	    "Define parameters of Executive Control section" \
	    "Define parameters of Case Control section" \
	    "" \
	    "Define parameters of Dynamic Analysis" \
	    "Define parameters of Buckling Analysis" \
	    "Define parameters of NonLinear Analysis" \
	    "" \
	    "Generate Mesh" "Write Nastran Input file" }
    
     set MyBitmapsNames(0,0) ""
     set MyBitmapsCommands(0,0) ""

    # prefix values:
    #          Pre        Only active in the preprocessor
    #          Post       Only active in the postprocessor
    #          PrePost    Active Always

    set prefix Pre

    set ProblemTypePriv(toolbarwin) [CreateOtherBitmaps MyBar "My toolbar" \
	    MyBitmapsNames MyBitmapsCommands \
	    MyBitmapsHelp $dir "MyBitmaps [list $dir]" $type $prefix]
    AddNewToolbar "$ProgramName bar" ${prefix}MyBarWindowGeom \
	    "MyBitmaps [list $dir]"

    # button number 3
     set ProblemTypePriv(loadcasewin) $ProblemTypePriv(toolbarwin).0
 
     if { [info exists ProblemTypePriv(loadcaseimg1)] } {
	 ChangeToLoadCase 1
     }

}

proc EndMyBitmaps {} {
    global ProblemTypePriv ProgramName
    
    ReleaseToolbar "$ProgramName bar"
    rename MyBitmaps ""
    
    catch { destroy $ProblemTypePriv(toolbarwin) }
}
# proc CorrectExpSameLength { realnum } {
#     set res  [CorrectExp $realnum]
#     if { [string length $realnum] > [string length $res] } {
#         set res " $res"
#     }
#     return $res
# }

    

